/*
 * Copyright (C) 1997 by Uwe Steinmann
 * copied from lcd-0.5.5
 */

#ifndef _LCD_H
#define _LCD_H

#ifndef copy_from_user
#define copy_from_user memcpy_fromfs
#define copy_to_user memcpy_tofs
#endif

struct char_def {                       /* user defined characters */
	int char_nr;			/* number of char (0, ..)  */
	char data[8*5];			/* char data, line by line */
};

struct lcd_info {
	char rows;
	char cols;
	char x;
	char y;
	char cursor;
	char blink;
	char display;
	char disp_switch;
	char busy;
  char raw;
	char exist;
  char dummy;
  int  switch_time;
};

/* IOCTL numbers to set some things */
#define LCD_S_CURSOR		0x3F01  /* Turn cursor on/off */
#define LCD_S_BLINK 		0x3F02  /* Turn blinking cursor on/off */
#define LCD_S_DISPSHFT		0x3F03  /* Turn display shift on/off */
#define LCD_S_SHIFT		0x3F04  /* Set shift direction */
#define LCD_S_DISP		0x3F05  /* Turn display on/off */
#define LCD_S_CURX		0x3F06  /* Set cursor x-position */
#define LCD_S_CURY		0x3F07  /* Set cursor y-position */
#define LCD_S_WAIT		0x3F08  /* Set time in microsec after oper. */
#ifdef TO_BE_REMOVED_SOON
#define LCD_S_PORT		0x3F09  /* Set printer port (0, 1, 2) */
					/* Port0=0x3bc, Port1=0x378, Port2=0x278 */
#endif TO_BE_REMOVED_SOON
#define LCD_S_DSPSHFT		0x3F0A  /* Toggle display/cursor move */
#define LCD_S_CHAR		0x3F0B  /* Set user chars */
#ifdef TO_BE_REMOVED_SOON
#define LCD_S_ROWS		0x3F0C  /* Set number of rows */
#define LCD_S_COLS		0x3F0D  /* Set number of columns */
#endif TO_BE_REMOVED_SOON
#define LCD_S_RAW		0x3F0E  /* Set raw mode on/off */
#define LCD_S_SWITCH            0x3F0F  /* Set switch on/off */
#define LCD_S_SWITCH_TIME	0x3F10  /* Time between disp. switching */

/* IOCTL numbers to get some things */
#define LCD_G_CURSOR		0x3F41	/* Turn cursor on/off */
#define LCD_G_BLINK 		0x3F42  /* Turn blinking cursor on/off */
#define LCD_G_DISPSHFT		0x3F43  /* Turn display shift on/off */
#define LCD_G_SHIFT		0x3F44  /* Set shift direction */
#define LCD_G_DISP		0x3F45  /* Turn display on/off */
#define LCD_G_CURX		0x3F46  /* Set cursor x-position */
#define LCD_G_CURY		0x3F47  /* Set cursor y-position */
#define LCD_G_WAIT		0x3F48  /* Set time in microsec after oper. */
#define LCD_G_PORT		0x3F49  /* Set printer port (0, 1, 2) */
					/* Port0=0x3bc, Port1=0x378, Port2=0x278 */
#define LCD_G_DSPSHFT		0x3F4A  /* Toggle display/cursor move */
#define LCD_G_CHAR		0x3F4B  /* Set user chars */
#define LCD_G_ROWS		0x3F4C  /* Set number of rows */
#define LCD_G_COLS		0x3F4D  /* Set number of columns */
#define LCD_G_RAW	        0x3F4E  /* Get raw mode */
#define LCD_G_SWITCH	        0x3F4F  /* Get switch */
#define LCD_G_SWITCH_TIME	0x3F50  /* Time between disp. switching */


#define LCDCLEAR		0x3F81  /* Clear display, move cursor to (1,1) */
#define LCDRESET		0x3F82  /* Reset display */
#define LCD_S_OUT		0x3F83	/* Output with STROBE */


/* IOCTL numbers for /dev/lcdctrl */
#define LCD_S_SEL		0x3FC0  /* Select a virtual Display (0,..)*/
#define LCD_S_SWITCHALL	        0x3FC1  /* Turn virt. disp. switching on */
#define LCD_G_SEL		0x3FE0  /* Select a virtual Display (0,..)*/
#define LCD_G_SWITCHALL   	0x3FE1  /* Check virt. disp. switching on */
#define LCD_G_NR                0x3FE3  /* Number of displays */

#define LCD_INFO                0x3FF0

#define LCD_ON			0x1
#define LCD_OFF			0x0
#define LCD_RIGHT		0x1
#define LCD_LEFT		0x0

#define LCD_MAJOR 120

#endif
